--

package body Bounded_Buffers is

   protected body Buffer_Type is

      entry Put (Item : Item_Type) when Count < Buffer_Size is
      begin
         Buffer_Store (Next_In) := Item;
         Next_In                := Next_In mod Buffer_Size + 1;
         Count                  := Count + 1;
      end Put;

      -- -- --

      entry Get (Item : out Item_Type) when Count > 0 is
      begin
         Item     := Buffer_Store (Next_Out);
         Next_Out := Next_Out mod Buffer_Size + 1;
         Count    := Count - 1;
      end Get;

      -- -- --

      function Is_Full return Boolean is
      begin
         return (Count = Buffer_Size);
      end Is_Full;

   end Buffer_Type;

   -- -- --

   procedure Put (Buf : in out Buffer_Type; Item : in Item_Type) is
   begin
      Buf.Put (Item);
   end Put;

   procedure Get (Buf : in out Buffer_Type; Item : out Item_Type) is
   begin
      Buf.Get (Item);
   end Get;

   function Is_Full (Buf : Buffer_Type) return Boolean is
   begin
      return Buf.Is_Full;
   end Is_Full;

end Bounded_Buffers;
