--

separate (Prime_Numbers)

task body Sieve_Task_Type is

   Output_Buffer   : access Sieve_Buffer_Type := new Sieve_Buffer_Type;
   Next_Sieve_Task : access Sieve_Task_Type;

   Num      : Natural;
   My_Prime : Natural;

begin

   Buffers.Get (Input_Buffer.all, My_Prime);

   if My_Prime = 0 then
      Num := 0;
      goto The_End;
   end if;

   -- -- --

   if (My_Prime - Last_Prime) = 2 then

      Printing : declare
         Str : String := ">> PrimePair: " & Positive'Image (Last_Prime) & " | " & Positive'Image (My_Prime);
      begin
         Printer_Task.Print (Str);
      end Printing;

      Nb_Of_Prime_Pairs := Natural'Succ (Nb_Of_Prime_Pairs);

   end if;

   Last_Prime := My_Prime;

   -- -- --

   loop
      Buffers.Get (Input_Buffer.all, Num);

      if Num = 0 then
         goto The_End;
      end if;

      exit when Num rem My_Prime /= 0;
   end loop;

   -- -- --

   --  There is a new prime number,
   --  so create a new task to handle this number
   --  with an associated buffer
   --
   Next_Sieve_Task := Get_New_Sieve_Task (In_Buf => Output_Buffer);

   Buffers.Put (Output_Buffer.all, Num);

   -- -- --

   loop
      Buffers.Get (Input_Buffer.all, Num);

      exit when Num = 0;

      if Num rem My_Prime /= 0 then
         Test_Buffer_Is_Full (Output_Buffer);

         Buffers.Put (Output_Buffer.all, Num);
      end if;

   end loop;

   -- -- --

   <<The_End>>
   Buffers.Put (Output_Buffer.all, Num);
   --
   -- Num is 0

   delay 1.0;

   if not Done then
      Done := True;

      Printer_Task.Print ("#> ---");
      Printer_Task.Print ("#> Number of prime pairs: " & Natural'Image (Nb_Of_Prime_Pairs));
      Printer_Task.Print ("## Enter CR to finish ...");
   end if;

exception
   when Event : others =>
      Printer_Task.Print ("#! Sieve_Task_Type: EXCEPTION");
      Printer_Task.Print (Exceptions.Exception_Information (Event));

end Sieve_Task_Type;
